#property copyright "Copyright  2010, GlennMT4Code"
#property link      "http://www.glennmetatradercode.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Black
#property indicator_color2 Black

extern string note1 = "Next 2 parms used on 1/5min charts";
extern int MovingAverage1 = 12;
extern int BBPeriod1 = 8;
extern string note2 = "Next 2 parms used on >=15min charts";
extern int MovingAverage2 = 21;
extern int BBPeriod2 = 9;
extern double BBDeviation = 0.75;
extern color ColourUpArr = Green;
extern color ColourDownArr = Red;
extern double BarPercent = 33.0;
extern int ArrowDistFromBar = 6;
extern int MaxBarsToCalculate = 500;
int g_period_140;
double g_ibuf_144[20000];
double g_ibuf_148[20000];
double gda_unused_152[20000];
double gda_156[20000];
double gda_160[20000];
double gd_164;
double gd_172;
double g_ima_180;
double gd_188;
double g_point_196;
double g_period_204;
double g_open_212 = 0.0;
double g_high_220 = 0.0;
double g_low_228 = 0.0;
double g_close_236 = 0.0;
double gd_244;
double gd_252;
double gd_260;
bool gi_268;
bool gi_272;
bool gi_276;
bool gi_280;
bool gi_284;
bool gi_288;

int init() {
   SetIndexStyle(0, DRAW_ARROW, EMPTY, 2);
   SetIndexArrow(0, 226);
   SetIndexBuffer(0, g_ibuf_144);
   SetIndexLabel(0, "ArrTop");
   SetIndexStyle(0, -1, EMPTY, EMPTY, ColourUpArr);
   SetIndexStyle(1, DRAW_ARROW, EMPTY, 2);
   SetIndexArrow(1, 225);
   SetIndexBuffer(1, g_ibuf_148);
   SetIndexLabel(1, "ArrBottom");
   SetIndexStyle(1, -1, EMPTY, EMPTY, ColourDownArr);
   ObjectDelete("Cmmt");
   Print("Init System17-Indicator happened ", TimeCurrent());
   Comment("System17-Indicator init:");
   return (0);
}

int deinit() {
   Print("DE-Init System17Indicator happened ");
   Comment("System17-Indicator deinit:");
   return (0);
}

int start() {
   if (MarketInfo(Symbol(), MODE_DIGITS) == 4.0 || MarketInfo(Symbol(), MODE_DIGITS) == 5.0) g_point_196 = 0.0001;
   else {
      if (MarketInfo(Symbol(), MODE_DIGITS) == 2.0 || MarketInfo(Symbol(), MODE_DIGITS) == 3.0) g_point_196 = 0.01;
      else g_point_196 = Point;
   }
   if (Period() == PERIOD_M1 || Period() == PERIOD_M5) {
      g_period_204 = MovingAverage1;
      g_period_140 = BBPeriod1;
   } else {
      g_period_204 = MovingAverage2;
      g_period_140 = BBPeriod2;
   }
   int l_bars_4 = Bars;
   if (l_bars_4 < 1) return (-1);
   int li_8 = IndicatorCounted();
   if (li_8 < 0) return (-1);
   if (li_8 > l_bars_4) return (-1);
   if (li_8 > 0) li_8--;
   int li_12 = l_bars_4 - li_8;
   if (li_12 > MaxBarsToCalculate) li_12 = MaxBarsToCalculate;
   for (int li_0 = li_12; li_0 >= 0; li_0--) {
      ClearArrTop(li_0);
      ClearArrBottom(li_0);
      g_high_220 = High[li_0];
      g_low_228 = Low[li_0];
      g_close_236 = Close[li_0];
      g_open_212 = Open[li_0];
      gd_188 = g_high_220 - g_low_228;
      gd_244 = g_high_220 - gd_188 * (BarPercent / 100.0);
      gd_252 = g_low_228 + gd_188 * (BarPercent / 100.0);
      GetBollingerBands(li_0);
      g_ima_180 = iMA(NULL, 0, g_period_204, 0, MODE_SMA, PRICE_CLOSE, li_0);
      gi_276 = FALSE;
      gi_280 = FALSE;
      gi_268 = FALSE;
      if (g_open_212 <= gd_252 && g_close_236 >= gd_244) gi_268 = TRUE;
      if (gda_156[li_0] > gda_156[li_0 + 1] || gda_160[li_0] > gda_160[li_0 + 1]) gi_276 = TRUE;
      if (iMA(NULL, 0, g_period_204, 0, MODE_SMA, PRICE_CLOSE, li_0) > iMA(NULL, 0, g_period_204, 0, MODE_SMA, PRICE_CLOSE, li_0 + 1)) gi_280 = TRUE;
      if (gi_268 && g_close_236 >= g_ima_180 && g_close_236 >= gd_164 && gi_276 && gi_280) SetArrBottom(li_0);
      gi_284 = FALSE;
      gi_288 = FALSE;
      gi_272 = FALSE;
      if (g_open_212 >= gd_244 && g_close_236 <= gd_252) gi_272 = TRUE;
      if (gda_156[li_0] < gda_156[li_0 + 1] || gda_160[li_0] < gda_160[li_0 + 1]) gi_284 = TRUE;
      if (iMA(NULL, 0, g_period_204, 0, MODE_SMA, PRICE_CLOSE, li_0) < iMA(NULL, 0, g_period_204, 0, MODE_SMA, PRICE_CLOSE, li_0 + 1)) gi_288 = TRUE;
      if (gi_272 && g_close_236 <= g_ima_180 && g_close_236 <= gd_172 && gi_284 && gi_288) SetArrTop(li_0);
   }
   gd_260 = Ask - Bid;
   Comment("System17-Indicator: Spread is " + DoubleToStr(gd_260, 4));
   return (0);
}

void GetBollingerBands(int ai_0) {
   double ld_28;
   double ld_12 = 0.0;
   int li_36 = ai_0 + g_period_140 - 1;
   double l_ima_20 = iMA(NULL, 0, g_period_140, 0, MODE_SMA, PRICE_CLOSE, ai_0);
   while (li_36 >= ai_0) {
      ld_28 = Close[li_36] - l_ima_20;
      ld_12 += ld_28 * ld_28;
      li_36--;
   }
   double ld_4 = BBDeviation * MathSqrt(ld_12 / g_period_140);
   gda_156[ai_0] = l_ima_20 + ld_4;
   gda_160[ai_0] = l_ima_20 - ld_4;
   gd_164 = gda_156[ai_0];
   gd_172 = gda_160[ai_0];
}

void SetArrBottom(int ai_0) {
   double ld_4 = ArrowDistFromBar * g_point_196;
   g_ibuf_148[ai_0] = Low[ai_0] - ld_4;
}

void SetArrTop(int ai_0) {
   double ld_4 = ArrowDistFromBar * g_point_196;
   g_ibuf_144[ai_0] = High[ai_0] + ld_4;
}

void ClearArrTop(int ai_0) {
   g_ibuf_144[ai_0] = 0;
}

void ClearArrBottom(int ai_0) {
   g_ibuf_148[ai_0] = 0;
}